//
//  iBarcode.m
//  iBarcode
//
//  Created by b4j on 11/24/14.
//  Copyright (c) 2014 Anywhere Software. All rights reserved.
//

#import "iBarcode.h"

#import "MTBBarcodeScanner.h"

@implementation iBarcode {
    MTBBarcodeScanner *scanner;
}
- (NSString *)TYPE_QR {
    return AVMetadataObjectTypeQRCode;
}

- (NSString *)TYPE_UPCE {
    return AVMetadataObjectTypeUPCECode;
}

- (NSString *)TYPE_39 {
    return AVMetadataObjectTypeCode39Code;
}

- (NSString *)TYPE_39Mod43 {
    return AVMetadataObjectTypeCode39Mod43Code;
}

- (NSString *)TYPE_EAN13 {
    return AVMetadataObjectTypeEAN13Code;
}

- (NSString *)TYPE_EAN8 {
    return AVMetadataObjectTypeEAN8Code;
}

- (NSString *)TYPE_93 {
    return AVMetadataObjectTypeCode93Code;
}

- (NSString *)TYPE_128 {
    return AVMetadataObjectTypeCode128Code;
}

- (NSString *)TYPE_PDF417 {
    return AVMetadataObjectTypePDF417Code;
}

- (NSString *)TYPE_Interleaved2of5 {
    return @"org.ansi.Interleaved2of5";
}

- (NSString *)TYPE_ITF14 {
    return @"org.gs1.ITF14";
}

- (NSString *)TYPE_DataMatrix {
    return @"org.iso.DataMatrix";
}

- (void)setTorchMode:(int)TorchMode {
    scanner.torchMode = (MTBTorchMode) TorchMode;
}

- (int)TorchMode {
    return scanner.torchMode;
}

- (BOOL)AllowTapToFocus {
    return scanner.allowTapToFocus;
}

- (void)setAllowTapToFocus:(BOOL)AllowTapToFocus {
    scanner.allowTapToFocus = AllowTapToFocus;
}


- (int)TORCH_AUTO {
    return  MTBTorchModeAuto;
}

- (int)TORCH_ON {
    return MTBTorchModeOn;
}

- (int)TORCH_OFF {
    return  MTBTorchModeOff;
}



- (void)Initialize:(B4I *)bi :(NSString *)EventName :(UIView *)View {
    [self Initialize2:bi :EventName :View :[B4IObjectWrapper createWrapper:[B4IList new] object:[MTBBarcodeScanner defaultMetaDataObjectTypes]]];
}
- (void)Initialize2:(B4I *)bi :(NSString *)EventName :(UIView *)View :(B4IList *)Types {
    [B4IObjectWrapper setBIAndEventName:self :bi :EventName];
    scanner = [[MTBBarcodeScanner alloc] initWithMetadataObjectTypes:Types.object previewView:View];
    [MTBBarcodeScanner requestCameraPermissionWithSuccess:^(BOOL success) {
        [B4IObjectWrapper raiseUIEvent:self :@"_ready:" :@[@(success)]];
    }];
}



- (void)Resize {
    scanner.previewLayer.frame = scanner.previewView.bounds;
}
- (void)Start {
    [scanner startScanningWithResultBlock:^(NSArray *codes) {
        if (codes.count > 0) {
           B4IList *l1 = [B4IList new];
           l1.object = codes;
            [B4IObjectWrapper raiseEvent:self :@"_detected:" :@[l1]];
        }
    }];
}
- (void)Stop {
    [scanner stopScanning];
}
@end

@implementation B4IBarcodeCode
#define OBJ ((AVMetadataMachineReadableCodeObject *) self.object)
+ (Class)getClass {
    return [AVMetadataMachineReadableCodeObject class];
}

- (NSString *)Value {
    return OBJ.stringValue;
}

@end

